#!/usr/bin/python
#Usage : python config_dialog.py [CONF_PYDICT]

import sys
try:
	from qt import *
except:
	import os
	os.popen("kdialog --sorry 'You need PyQt to use Aero AIO configuration utility.'")
	ok = False
else:
	ok = True

arg = compile('conf = ' + sys.argv[1], '<string>', 'exec')
exec arg

def getIndex(value, lst):
	i = 0
	index = 0
	for a in lst:
		if ( a == value ):
			index = i
		i = i + 1
	return index

def stringToList(string):
	if ( string == "[]"):
		return []
	else:
		import re
		s = string.strip("[]")
		s = s.replace(', ', ',')
		s = s.replace("'", "")
		s = s.split(',')
		i = 0
		for a in s:
			try:
				s[i] = int(a)
			except:
				pass
			i = i + 1
		return s

def themeList():
	import os
	f = os.popen("ls -1 " + conf["theme_path"] + "Themes")
	a = f.read()
	f.close()
	a = a.split('\n')
	if ( a[-1] == ""):
		a =  a[0:-1]
	c = []
	for b in a:
		c.append(b)
	return c

def iconList():
	import os
	f = os.popen("ls -1 " + conf["theme_path"] + "icons")
	a = f.read()
	f.close()
	a = a.split('\n')
	if ( a[-1] == ""):
		a =  a[0:-1]
	c = []
	for b in a:
		c.append(b)
	return c

class inputLine:
	
	def __init__(self, parent, x, y, title):
		self.label = QLabel(parent)
		self.label.setText(title + " ")
		self.label.setGeometry(x, y, 150, 24)
		self.label.setAlignment(Qt.AlignRight)
		
		self.line = QLineEdit(parent)
		self.line.setGeometry(x + 150, y, 150, 20)
	
	def setEnabled(self, bool):
		self.label.setEnabled(bool)
		self.line.setEnabled(bool)
	
	def text(self):
		return self.line.text()
	
	def isEnabled(self):
		return self.line.isEnabled()

class partitionBox(QGroupBox):
	def __init__(self, parent, x, y, title, name, mountpoint, enabled):
		apply(QGroupBox.__init__, (self,) + (parent,))
		self.setTitle(title)
		self.setGeometry(x, y, 320, 80)
		
		if not(enabled):
			self.setEnabled(False)
		
		self.label1 = QLabel(self)
		self.label1.setText("Name :")
		self.label1.setGeometry(10, 20, 150, 24)
		self.label2 = QLabel(self)
		self.label2.setText("Mountpoint :")
		self.label2.setGeometry(10, 50, 150, 24)
		
		self.line1 = QLineEdit(self)
		self.line1.setText(name)
		self.line1.setGeometry(160, 20, 150, 20)
		self.line2 = QLineEdit(self)
		self.line2.setText(mountpoint)
		self.line2.setGeometry(160, 50, 150, 20)

class autoSwitchInput:
	
	def __init__(self, parent, x, y, title):
		self.label = QLabel(parent)
		self.label.setText(title)
		self.label.setGeometry(x, y, 20, 24)
		
		self.box = QComboBox(parent)
		self.box.setGeometry(x + 30 , y, 150, 24)
		self.menu_list = ['', 'SysInfos', 'CpuMem', 'Partitions', 'Network', 'Clock', 'Calendar', 'Mail', 'AcpiInfos']
		Qlist = QStringList()
		for a in self.menu_list:
			Qlist.append(a)
		self.box.insertStringList(Qlist)

class Page1_Box1(QGroupBox):
	
	def __init__(self, *args):
		apply(QGroupBox.__init__, (self,) + args)
		self.setTitle("Pages to display")
		
		self.check1 = QCheckBox("System Infomations", self)
		self.check1.setGeometry(20,40,200,20)
		self.check2 = QCheckBox("Cpu load and memory", self)
		self.check2.setGeometry(20,70,200,20)
		self.check3 = QCheckBox("Partition(s) informations", self)
		self.check3.setGeometry(20,100,200,20)
		self.check4 = QCheckBox("Network interface(s)", self)
		self.check4.setGeometry(20,130,200,20)
		self.check5 = QCheckBox("Clock", self)
		self.check5.setGeometry(20,160,200,20)
		self.check6 = QCheckBox("Calendar", self)
		self.check6.setGeometry(20,190,200,20)
		self.check7 = QCheckBox("Mail check", self)
		self.check7.setGeometry(20,220,200,20)
		self.check8 = QCheckBox("Energy monitor (laptops)", self)
		self.check8.setGeometry(20,250,200,20)
		self.check9 = QCheckBox("Enable auto-switching", self)
		self.check9.setGeometry(20,350,200,20)
		
		configuration = conf["configuration"]
		if ( configuration[0] == '1' ):
			self.check1.setChecked(True)
		if ( configuration[1] == '1' ):
			self.check2.setChecked(True)
		if ( configuration[2] == '1' ):
			self.check3.setChecked(True)
		if ( configuration[3] == '1' ):
			self.check4.setChecked(True)
		if ( configuration[4] == '1' ):
			self.check5.setChecked(True)
		if ( configuration[5] == '1' ):
			self.check6.setChecked(True)
		if ( configuration[6] == '1' ):
			self.check7.setChecked(True)
		if ( configuration[7] == '1' ):
			self.check8.setChecked(True)
		if ( len(conf["autoswitch"]) > 2 ):
			self.check9.setChecked(True)

class Page1_Box2(QGroupBox):
	
	def __init__(self, *args):
		apply(QGroupBox.__init__, (self,) + args)
		self.setTitle("Theme")
		
		self.text_theme = QLabel(self)
		self.text_theme.setText("Select a theme :")
		self.text_theme.setGeometry(10,30,150,24)
		
		self.themeBox = QComboBox( self)
		self.themeBox.setGeometry(280,30,150,24)
		self.theme_list = themeList()
		Qlist = QStringList()
		for a in self.theme_list:
			Qlist.append(a)
		self.themeBox.insertStringList(Qlist)
		theme_index = getIndex(conf["theme"], self.theme_list)
		self.themeBox.setCurrentItem(theme_index)
		
		self.text_icons = QLabel(self)
		self.text_icons.setText("Select an icon set :")
		self.text_icons.setGeometry(10,70,200,24)
		
		self.iconBox = QComboBox( self)
		self.iconBox.setGeometry(280,70,150,24)
		self.icon_list = iconList()
		Qlist = QStringList()
		for a in self.icon_list:
			Qlist.append(a)
		self.iconBox.insertStringList(Qlist)
		icon_index = getIndex(conf["icon"], self.icon_list)
		self.iconBox.setCurrentItem(icon_index)
		
		self.theme_img = QLabel(self)
		self.theme_img.setGeometry(100,125,240,160)
		img = QImage(conf["theme_path"] + 'Themes/' + self.theme_list[theme_index] + '/preview.png')
		theme_img_pixmap = QPixmap(img)
		self.theme_img.setPixmap(theme_img_pixmap)
		self.connect(self.themeBox, SIGNAL("activated(int)"), self.updateTheme)
		
		self.text_color = QLabel(self)
		self.text_color.setText("Choose text color :")
		self.text_color.setGeometry(10,320,200,24)
		
		self.button_color = QPushButton(self)
		self.button_color.setGeometry(180,320,50,24)
		self.color = conf["color"]
		self.color = QColor(self.color[0], self.color[1], self.color[2])
		self.pixmap_color = QPixmap(40,14,-1)
		self.pixmap_color.fill(self.color)
		self.button_color.setPixmap(self.pixmap_color)
		self.connect(self.button_color, SIGNAL("released()"), self.button_colorClicked)
		
		self.checkShadow = QCheckBox("Enable text shadows", self)
		self.checkShadow.setGeometry(260,320,160,24)
		if ( conf["shadow"] ):
			self.checkShadow.setChecked(True)
		
		self.text_titleColor = QLabel(self)
		self.text_titleColor.setText("Choose titles' color :")
		self.text_titleColor.setGeometry(10,360,200,24)
		
		self.button_titleColor = QPushButton(self)
		self.button_titleColor.setGeometry(180,360,50,24)
		self.titleColor = conf["titleColor"]
		self.titleColor = QColor(self.titleColor[0], self.titleColor[1], self.titleColor[2])
		self.pixmap_titleColor = QPixmap(40,14,-1)
		self.pixmap_titleColor.fill(self.titleColor)
		self.button_titleColor.setPixmap(self.pixmap_titleColor)
		self.connect(self.button_titleColor, SIGNAL("released()"), self.button_titleColorClicked)
		
		self.checkTitleShadow = QCheckBox("Enable title shadows", self)
		self.checkTitleShadow.setGeometry(260,360,160,24)
		if ( conf["titleShadow"] ):
			self.checkTitleShadow.setChecked(True)
	
	def button_colorClicked(self):
		self.color = QColorDialog.getColor(self.color, self, "Choose text color")
		self.pixmap_color.fill(self.color)
		self.button_color.setPixmap(self.pixmap_color)
	
	def button_titleColorClicked(self):
		self.titleColor = QColorDialog.getColor(self.titleColor, self, "Choose titles' color")
		self.pixmap_titleColor.fill(self.titleColor)
		self.button_titleColor.setPixmap(self.pixmap_titleColor)
	
	def updateTheme(self, arg):
		img = QImage(conf["theme_path"] + 'Themes/' + self.theme_list[arg] + '/preview.png')
		theme_img_pixmap = QPixmap(img)
		self.theme_img.setPixmap(theme_img_pixmap)
		import re
		f = open(conf["theme_path"] + 'Themes/' + self.theme_list[arg] + '/theme')
		a = f.read()
		f.close()
		match = re.search("color=(\[.*\])\ntitle_color=(\[.*\])\nicon_set=(.*)", a)
		self.color = stringToList(match.group(1))
		self.color = QColor(self.color[0], self.color[1], self.color[2])
		self.pixmap_color.fill(self.color)
		self.button_color.setPixmap(self.pixmap_color)
		self.titleColor = stringToList(match.group(2))
		self.titleColor = QColor(self.titleColor[0], self.titleColor[1], self.titleColor[2])
		self.pixmap_titleColor.fill(self.titleColor)
		self.button_titleColor.setPixmap(self.pixmap_titleColor)
		icon = match.group(3)
		icon_index = getIndex(icon, self.icon_list)
		self.iconBox.setCurrentItem(icon_index)
		

class Page4_Box(QGroupBox):
	
	def __init__(self, parent, title, iface_list):
		apply(QGroupBox.__init__, (self,) + (parent,))
		self.setTitle(title)
		
		self.name = inputLine(self,10,40,"Interface name :	")
		self.name.line.setText(iface_list[0])
		self.speedLabel = QLabel(self)
		self.speedLabel.setText("Maximum speeds in kB/s :")
		self.speedLabel.setGeometry(10, 80, 200, 24)
		
		self.maxIn_label = QLabel(self)
		self.maxIn_label.setGeometry(40,120,100,24)
		self.maxIn_label.setText("Download :")
		self.maxOut_label = QLabel(self)
		self.maxOut_label.setGeometry(40,160,100,24)
		self.maxOut_label.setText("Upload :")
		
		self.spinIn = QSpinBox(1,100000,1,self)
		self.spinIn.setGeometry(200, 120, 70, 20)
		self.spinIn.setValue(iface_list[1])
		self.spinOut = QSpinBox(1,100000,1,self)
		self.spinOut.setGeometry(200, 160, 70, 20)
		self.spinOut.setValue(iface_list[2])

class Mail_Box(QGroupBox):
	
	def __init__(self, parent, num, param_list):
		apply(QGroupBox.__init__, (self,) + (parent,))
		self.setTitle("Account " + str(num))
		
		self.box = QComboBox( self)
		self.box.setGeometry(120,30,90,24)
		self.account_list = ["POP", "GMail"]
		Qlist = QStringList()
		for a in self.account_list:
			Qlist.append(a)
		self.box.insertStringList(Qlist)
		self.connect(self.box, SIGNAL("activated(int)"), self.updateBox)
		if (param_list[1] == "gmail"):
			self.box.setCurrentItem(1)
		
		self.typeLabel = QLabel(self)
		self.nameLabel = QLabel(self)
		self.serverLabel = QLabel(self)
		self.loginLabel = QLabel(self)
		self.passLabel = QLabel(self)
		
		self.typeLabel.setGeometry(10,30,100,24)
		self.nameLabel.setGeometry(10,60,200,24)
		self.serverLabel.setGeometry(10,120,110,24)
		self.loginLabel.setGeometry(10,180,110,24)
		self.passLabel.setGeometry(10,240,110,24)
		
		self.typeLabel.setText("Account type :")
		self.nameLabel.setText("Name to display :")
		self.serverLabel.setText("Server (pop) :")
		self.loginLabel.setText("Login :")
		self.passLabel.setText("Password :")
		
		self.nameLine = QLineEdit(self)
		self.serverLine = QLineEdit(self)
		self.loginLine = QLineEdit(self)
		self.passLine = QLineEdit(self)
		self.passLine.setEchoMode(QLineEdit.Password)
		
		self.nameLine.setGeometry(15,90,190,20)
		self.serverLine.setGeometry(15,150,190,20)
		self.loginLine.setGeometry(15,210,190,20)
		self.passLine.setGeometry(15,270,190,20)
		
		self.nameLine.setText(param_list[0])
		self.serverLine.setText(param_list[1])
		self.loginLine.setText(param_list[2])
		self.passLine.setText(param_list[3])
	
	def updateBox(self, arg):
		if (arg == 0):
			self.serverLabel.setEnabled(True)
			self.serverLine.setEnabled(True)
			self.serverLine.setText("pop.")
		elif (arg == 1):
			self.serverLabel.setEnabled(False)
			self.serverLine.setEnabled(False)
			self.serverLine.setText("gmail")

class Mail_Account:
	
	def __init__(self, parent, x, y, num, param_list):
		self.check = QCheckBox("Enable account " + str(num) , parent)
		self.check.setGeometry(x, y, 200, 20)
		self.group = Mail_Box(parent, num, param_list)
		self.group.setGeometry(x, y + 30,220,310)
		parent.connect(self.check, SIGNAL("toggled(bool)"), self.group, SLOT("setEnabled(bool)"))


class Page1(QWidget):
	
	def __init__(self, *args):
		apply(QWidget.__init__, (self,) + args)
		
		self.group1 = Page1_Box1(self)
		#group1.setGeometry(10,10,200,200)
		self.group1.move(10,10)
		self.group1.setMinimumSize(230,400)
		
		self.group2 = Page1_Box2(self)
		self.group2.move(250,10)
		self.group2.setMinimumSize(440,400)
		


class Page2(QWidget):
	
	def __init__(self, *args):
		apply(QWidget.__init__, (self,) + args)
		self.label = QLabel(self)
		self.label.setText("Choose an update interval of memory and cpu frequency (in seconds) :")
		self.label.setGeometry(50,30,500,24)
		
		self.spinBox = QSpinBox(1,3600,1,self)
		self.spinBox.setGeometry(550,30,60,24)
		self.spinBox.setValue(conf["cpu_interval"])
		
		
		self.label1 = QLabel(self)
		self.label1.setText('Path to your "temperature" file (default: "/proc/acpi/thermal_zone/THRM/temperature") :')
		self.label1.setGeometry(50,80,580,24)
		self.lineEdit = QLineEdit(self)
		self.lineEdit.setGeometry(70, 120, 490, 24)
		self.lineEdit.setText(conf["temp_file"])
		
		self.button = QPushButton(self)
		self.button.setGeometry(566,119,26,26)
		img = QImage(conf["theme_path"] + 'scripts/fileopen.png')
		img_pixmap = QPixmap(img)
		self.button.setPixmap(img_pixmap)
		self.connect(self.button, SIGNAL("released()"), self.buttonClicked)
		
		self.text_graphColor = QLabel(self)
		self.text_graphColor.setText("Choose graph color :")
		self.text_graphColor.setGeometry(237,170,160,24)
		
		self.button_graphColor = QPushButton(self)
		self.button_graphColor.setGeometry(407,170,50,24)
		self.graphColor = conf["graphColor"]
		self.graphColor = QColor(self.graphColor[0], self.graphColor[1], self.graphColor[2])
		self.pixmap_graphColor = QPixmap(40,14,-1)
		self.pixmap_graphColor.fill(self.graphColor)
		self.button_graphColor.setPixmap(self.pixmap_graphColor)
		self.connect(self.button_graphColor, SIGNAL("released()"), self.button_graphColorClicked)
		
	
	def buttonClicked(self):
		acDir = QFileDialog.getOpenFileName("/proc/acpi/thermal_zone", "temperature", self, "ACDir", 'Select your "temperature" file')
		self.lineEdit.setText(acDir)
	
	def button_graphColorClicked(self):
		self.graphColor = QColorDialog.getColor(self.graphColor, self, "Choose graph color")
		self.pixmap_graphColor.fill(self.graphColor)
		self.button_graphColor.setPixmap(self.pixmap_graphColor)

class Page3(QWidget):
	
	def __init__(self, *args):
		apply(QWidget.__init__, (self,) + args)
		self.label = QLabel(self)
		self.label.setText("Select the number of partitions you want to monitor :")
		self.label.setGeometry(30,20,400,24)
		
		self.partition_list = conf["partition_list"]
		lenght = len(self.partition_list) / 2
		
		self.slider_label = QLabel(self)
		self.slider_label.setText("1   2   3   4   5   6   7   8")
		self.slider_label.setGeometry(435,4,180,24)
		self.slider = QSlider(1,8,1,lenght,Qt.Horizontal,self)
		self.slider.setGeometry(430,24,180,24)
		#self.slider.setTickmarks(QSlider.Above)
		#self.slider.setTracking(True)
		#self.slider.setValue(int(sys.argv[7]))
		
		self.lineEdit_list = []
		x = 20
		y = 60
		for i in range(8):
			y = 60 + ( i / 2 ) * 90
			if ( i < lenght ):
				name = self.partition_list[2*i]
				mountpoint = self.partition_list[2*i+1]
				enabled = True
			else:
				name = ""
				mountpoint = ""
				enabled = False
			self.lineEdit_list.append(partitionBox(self,x,y,"Partition " + str(i+1), name, mountpoint, enabled))
			if ( x == 20 ):
				x = 360
			elif ( x == 360 ):
				x = 20
		
		self.connect(self.slider, SIGNAL("valueChanged(int)"), self.updateLineEdits)
	
	def updateLineEdits(self, arg):
		self.lineEdit_list[arg - 1].setEnabled(True)
		if ( arg < 8 ):
			self.lineEdit_list[arg].setEnabled(False)

class Page4(QWidget):
	
	def __init__(self, *args):
		apply(QWidget.__init__, (self,) + args)
		self.label = QLabel(self)
		self.label.setText("Choose a connection checking interval (in minutes) :")
		self.label.setGeometry(100,20,400,24)
		self.spinBox = QSpinBox(1,3600,1,self)
		self.spinBox.setGeometry(500,20,60,24)
		self.spinBox.setValue(conf["net_interval"]/60)
		
		self.check = QCheckBox("Enable second interface", self)
		self.check.setGeometry(360,70,200,20)
		
		self.net_list = conf["net_list"]
		lenght = len(self.net_list)
		
		if ( lenght == 0 ):
			list_group1 =["", 1, 1]
			list_group2 =["", 1, 1]
		elif ( lenght == 3 ):
			list_group1 =self.net_list
			list_group2 =["", 1, 1]
		elif ( lenght == 6 ):
			list_group1 =self.net_list[0:3]
			list_group2 =self.net_list[3:6]
		
		self.group1 = Page4_Box(self, "Interface 1", list_group1)
		self.group1.move(10,100)
		self.group1.setMinimumSize(330,200)
		
		self.group2 = Page4_Box(self, "Interface 2", list_group2)
		self.group2.move(360,100)
		self.group2.setMinimumSize(330,200)
		
		if ( lenght <= 3 ):
			self.group2.setEnabled(False)
		elif ( lenght == 6 ):
			self.check.setChecked(True)
		self.connect(self.check, SIGNAL("toggled(bool)"), self.group2, SLOT("setEnabled(bool)"))

class Page5(QWidget):
	
	def __init__(self, *args):
		apply(QWidget.__init__, (self,) + args)
		self.label = QLabel(self)
		self.label.setText("Choose a mail checking interval (in minutes) :")
		self.label.setGeometry(100,20,400,24)
		self.spinBox = QSpinBox(10,600,1,self)
		self.spinBox.setGeometry(500,20,60,24)
		self.spinBox.setValue(conf["mail_interval"]/60)
		
		self.mail_list = conf["mail_list"]
		lenght = len(self.mail_list)
		num = lenght / 4
		
		self.box_list = []
		x = 10
		for i in range(3):
			if ( i >= num ):
				param_list = ["","","",""]
			else:
				param_list = self.mail_list[4*i:4*(i+1)]
			self.box_list.append(Mail_Account(self, x, 70, i + 1, param_list))
			if ( i >= num ):
				self.box_list[i].group.setEnabled(False)
			else:
				self.box_list[i].check.setChecked(True)
			x = x + 230

class Page6(QWidget):
	
	def __init__(self, *args):
		apply(QWidget.__init__, (self,) + args)
		self.label1 = QLabel(self)
		self.label1.setText("Choose an update interval of battery load and ACPI state (in seconds) :")
		self.label1.setGeometry(50,30,500,24)
		
		self.spinBox = QSpinBox(1,3600,1,self)
		self.spinBox.setGeometry(550,30,60,24)
		self.spinBox.setValue(conf["batt_interval"])
		
		self.label1 = QLabel(self)
		self.label1.setText('Enter your AC directory (default: "/proc/acpi/ac_adapter/AC") :')
		self.label1.setGeometry(50,80,500,24)
		self.lineEdit = QLineEdit(self)
		self.lineEdit.setGeometry(70, 120, 490, 24)
		self.lineEdit.setText(conf["batt_stateDir"])
		
		self.button = QPushButton(self)
		self.button.setGeometry(566,119,26,26)
		img = QImage(conf["theme_path"] + 'scripts/fileopen.png')
		img_pixmap = QPixmap(img)
		self.button.setPixmap(img_pixmap)
		self.connect(self.button, SIGNAL("released()"), self.buttonClicked)
	
	def buttonClicked(self):
		acDir = QFileDialog.getExistingDirectory("/proc/acpi/ac_adapter", self, "ACDir", 'Select your "AC" directory (or "AC0")', True, True)
		self.lineEdit.setText(acDir)

class Page7(QWidget):
	
	def __init__(self, *args):
		apply(QWidget.__init__, (self,) + args)
		self.label1 = QLabel(self)
		self.label1.setText("Choose an interval after wich page will be switched to the next one (in seconds) :")
		self.label1.setGeometry(30,30,560,24)
		
		self.autoswitch = conf["autoswitch"]
		length = len(self.autoswitch)
		
		self.spinBox = QSpinBox(5,3600,1,self)
		self.spinBox.setGeometry(590,30,60,24)
		self.spinBox.setValue(self.autoswitch[0])
		
		self.box_list = []
		x = 125
		y = 100
		for i in range(8):
			self.box_list.append(autoSwitchInput(self, x, y, str(i+1) + " :"))
			y = y + 40
			if ( i == 3 ):
				x = 375
				y = 100
			if ( i + 1 < length ):
				index = getIndex(self.autoswitch[i + 1], self.box_list[i].menu_list)
				self.box_list[i].box.setCurrentItem(index)


class TabWidget(QTabWidget):

	def __init__(self, *args):
		apply(QTabWidget.__init__, (self,) + args)
		
		self.page1 = Page1(self)
		self.page2 = Page2(self)
		self.page3 = Page3(self)
		self.page4 = Page4(self)
		self.page5 = Page5(self)
		self.page6 = Page6(self)
		self.page7 = Page7(self)
		
		self.addTab(self.page1 , "Global settings")
		self.addTab(self.page2 , "Cpu and memory")
		self.addTab(self.page3 , "Partitions")
		self.addTab(self.page4 , "Network")
		self.addTab(self.page5 , "Mail")
		self.addTab(self.page6 , "Energy")
		self.addTab(self.page7 , "Auto-switching")
		
		configuration = conf["configuration"]
		if ( configuration[1] != '1' ):
			self.slotTab2(False)
		if ( configuration[2] != '1' ):
			self.slotTab3(False)
		if ( configuration[3] != '1' ):
			self.slotTab4(False)
		if ( configuration[6] != '1' ):
			self.slotTab5(False)
		if ( configuration[7] != '1' ):
			self.slotTab6(False)
		if ( len(conf["autoswitch"]) < 3 ):
			self.slotTab7(False)
		
		self.connect(self.page1.group1.check2, SIGNAL("stateChanged(int)"), self.slotTab2)
		self.connect(self.page1.group1.check3, SIGNAL("stateChanged(int)"), self.slotTab3)
		self.connect(self.page1.group1.check4, SIGNAL("stateChanged(int)"), self.slotTab4)
		self.connect(self.page1.group1.check7, SIGNAL("stateChanged(int)"), self.slotTab5)
		self.connect(self.page1.group1.check8, SIGNAL("stateChanged(int)"), self.slotTab6)
		self.connect(self.page1.group1.check9, SIGNAL("stateChanged(int)"), self.slotTab7)
	
	def slotTab2(self, arg):
		self.setTabEnabled(self.page2, arg)
	
	def slotTab3(self, arg):
		self.setTabEnabled(self.page3, arg)
	
	def slotTab4(self, arg):
		self.setTabEnabled(self.page4, arg)
	
	def slotTab5(self, arg):
		self.setTabEnabled(self.page5, arg)
	
	def slotTab6(self, arg):
		self.setTabEnabled(self.page6, arg)
	
	def slotTab7(self, arg):
		self.setTabEnabled(self.page7, arg)


class ConfigWindow(QMainWindow):

	def __init__(self, app):
		apply(QMainWindow.__init__, (self,))
		self.app = app
		QImg = QImage(conf["theme_path"] + 'scripts/icon.png')
		self.img = QPixmap(QImg)
		self.setIcon(self.img)
		self.tab=TabWidget(self)
		self.setCentralWidget(self.tab)
		self.setCaption("Aero - All In One Configuration utility")
		self.setGeometry(0,0,705,490)
		
		self.cancelButton = QPushButton("Cancel", self)
		self.applyButton = QPushButton("Apply", self)
		self.cancelButton.setGeometry(592,448,100,30)
		self.applyButton.setGeometry(482,448,100,30)
		
		self.connect(self.applyButton, SIGNAL("released()"), self.printConfig)
	
	def printConfig(self):
		group2 = self.tab.page1.group2
		color = [group2.color.red(), group2.color.green(), group2.color.blue()]
		titleColor = [group2.titleColor.red(), group2.titleColor.green(), group2.titleColor.blue()]
		shadow = group2.checkShadow.isChecked()
		titleShadow = group2.checkTitleShadow.isChecked()
		theme = group2.themeBox.currentText()
		icons = group2.iconBox.currentText()
		
		group1 = self.tab.page1.group1
		configuration = ""
		if ( group1.check1.isChecked() ):
			configuration = configuration + "1"
		else:
			configuration = configuration + "0"
		if ( group1.check2.isChecked() ):
			configuration = configuration + "1"
		else:
			configuration = configuration + "0"
		if ( group1.check3.isChecked() ):
			configuration = configuration + "1"
		else:
			configuration = configuration + "0"
		if ( group1.check4.isChecked() ):
			configuration = configuration + "1"
		else:
			configuration = configuration + "0"
		if ( group1.check5.isChecked() ):
			configuration = configuration + "1"
		else:
			configuration = configuration + "0"
		if ( group1.check6.isChecked() ):
			configuration = configuration + "1"
		else:
			configuration = configuration + "0"
		if ( group1.check7.isChecked() ):
			configuration = configuration + "1"
		else:
			configuration = configuration + "0"
		if ( group1.check8.isChecked() ):
			configuration = configuration + "1"
		else:
			configuration = configuration + "0"
		
		autoswitch = [self.tab.page7.spinBox.value()]
		if ( group1.check9.isChecked() ):
			for line in self.tab.page7.box_list:
				text = line.box.currentText()
				if ( text != "" ):
					autoswitch.append(str(text))
		
		temp_file = self.tab.page2.lineEdit.text()
		cpu_interval = self.tab.page2.spinBox.value()
		graphColor = [self.tab.page2.graphColor.red(), self.tab.page2.graphColor.green(), self.tab.page2.graphColor.blue()]
		
		partition_list = []
		for i in range(self.tab.page3.slider.value()):
			partition_list.append(str(self.tab.page3.lineEdit_list[i].line1.text()))
			partition_list.append(str(self.tab.page3.lineEdit_list[i].line2.text()))
		
		net_interval = self.tab.page4.spinBox.value() * 60
		group1 = self.tab.page4.group1
		net_list = [str(group1.name.text()), group1.spinIn.value(), group1.spinOut.value()]
		group2 = self.tab.page4.group2
		if ( self.tab.page4.check.isChecked() ):
			net_list.append(str(group2.name.text()))
			net_list.append(group2.spinIn.value())
			net_list.append(group2.spinOut.value())
		
		mail_interval = self.tab.page5.spinBox.value() * 60
		mail_list = []
		for module in self.tab.page5.box_list:
			if ( module.check.isChecked() ):
				mail_list.append(str(module.group.nameLine.text()))
				mail_list.append(str(module.group.serverLine.text()))
				mail_list.append(str(module.group.loginLine.text()))
				mail_list.append(str(module.group.passLine.text()))
		
		batt_stateDir = self.tab.page6.lineEdit.text()
		batt_interval = self.tab.page6.spinBox.value()
		
		conf_returned = { "color" : color,
			"titleColor" : titleColor,
			"shadow" : shadow,
			"titleShadow" : titleShadow,
			"theme" : str(theme),
			"icon" : str(icons),
			"configuration" : configuration,
			"temp_file" : str(temp_file),
			"cpu_interval" : cpu_interval,
			"graphColor" : graphColor,
			"partition_list" : partition_list,
			"net_list" : net_list,
			"net_interval" : net_interval,
			"mail_list" : mail_list,
			"mail_interval" : mail_interval,
			"batt_stateDir" : str(batt_stateDir),
			"batt_interval" : batt_interval,
			"autoswitch" : autoswitch}
		
		print "confr = " + str(conf_returned)
		
		self.app.quit()

def main(args):
	app=QApplication(args)
	win=ConfigWindow(app)
	win.show()
	app.connect(win.cancelButton, SIGNAL("released()"), app, SLOT("quit()"))
	app.connect(app, SIGNAL("lastWindowClosed()"), app, SLOT("quit()"))
	app.exec_loop()

if ( __name__=="__main__" and ok ):
	main(sys.argv)
