import karamba

class SysInfos:
	
	def __init__(self, widget, theme, color, titleColor):
		self.loaded = False
		self.pid = None
		self.title = karamba.createText(widget, 36, 34, 150, 20, "Infos")
		karamba.changeTextSize(widget, self.title, 20)
		self.line = karamba.createImage(widget, 31, 58, "Themes/" + theme + "/line.png")
		
		self.text0 = karamba.createText(widget, 38, 62, 300, 16, "")
		karamba.changeTextSize(widget, self.text0, 14)
		self.text1 = karamba.createText(widget, 38, 80, 300, 12, "Aero All In One (AIO) 0.7")
		self.text2 = karamba.createText(widget, 38, 96, 300, 12, "")
		self.text3 = karamba.createText(widget, 38, 112, 300, 12, "")
		self.text4 = karamba.createText(widget, 38, 128, 300, 12, "")
		self.text5 = karamba.createText(widget, 38, 144, 300, 12, "")
		self.text_list = [self.text0, self.text1, self.text2, self.text3, self.text4, self.text5]
		
		karamba.setTextSensor(widget, self.text0, 'sensor=program program="echo ${USER}@`hostname`" interval=3600000')
		karamba.setTextSensor(widget, self.text2, 'sensor=program program="uname -m -r" interval=3600000')
		karamba.setTextSensor(widget, self.text3, 'sensor=program program="kde-config --version | grep KDE" interval=3600000')
		karamba.setTextSensor(widget, self.text4, 'sensor=program program="kde-config --version | grep Qt" interval=3600000')
		karamba.setTextSensor(widget, self.text5, 'sensor=program program="users" interval=60000')
		
		karamba.changeTextColor(widget, self.title, titleColor[0], titleColor[1], titleColor[2])
		for meter in self.text_list:
			karamba.changeTextColor(widget, meter, color[0], color[1], color[2])
		self.loaded = True
	
	def updateColor(self, widget, color):
		for meter in self.text_list:
			karamba.changeTextColor(widget, meter, color[0], color[1], color[2])
	
	def shadow(self, widget, bool):
		if bool:
			for meter in self.text_list:
				karamba.changeTextShadow(widget, meter, 1)
		else:
			for meter in self.text_list:
				karamba.changeTextShadow(widget, meter, 0)
	
	def update(self, widget):
		pass
	
	def close(self, widget):
		karamba.deleteText(widget, self.title)
		karamba.deleteImage(widget, self.line)
		for meter in self.text_list:
			karamba.deleteText(widget, meter)